[LeetCode] 63. 不同路径 II
Posted powercai
tags:
篇首语:本文由小常识网(cha138.com)小编为大家整理,主要介绍了[LeetCode] 63. 不同路径 II相关的知识,希望对你有一定的参考价值。
题目链接 : https://leetcode-cn.com/problems/unique-paths-ii/
题目描述:
一个机器人位于一个 m x n 网格的左上角 (起始点在下图中标记为“Start” )。
机器人每次只能向下或者向右移动一步。机器人试图达到网格的右下角(在下图中标记为“Finish”)。
现在考虑网格中有障碍物。那么从左上角到右下角将会有多少条不同的路径?
网格中的障碍物和空位置分别用 1
和 0
来表示。
说明:m 和 n 的值均不超过 100。
示例:
示例 1:
输入:
[
[0,0,0],
[0,1,0],
[0,0,0]
]
输出: 2
解释:
3x3 网格的正中间有一个障碍物。
从左上角到右下角一共有 2 条不同的路径:
1. 向右 -> 向右 -> 向下 -> 向下
2. 向下 -> 向下 -> 向右 -> 向右
思路:
与上一题一样62. 不同路径,用动态规划
dp[i][j]
表示到i,j
位置的总步数,因为这道题有了障碍物,所以我们有障碍物的地方到不了就设置为0
动态方程: dp[i][j] = dp[i-1][j] + dp[i][j-1]
注意,针对dp
数组第一行,或者第一列要重新设置,考虑障碍物的情况!
当然空间还可以从二维优化到一维,参考上一题的题解,二维更容易理解一点!
再附上一个自顶向下的动态规划!
代码:
自底向上
def uniquePathsWithObstacles(self, obstacleGrid: List[List[int]]) -> int:
if not obstacleGrid or not obstacleGrid[0]: return 0
row = len(obstacleGrid)
col = len(obstacleGrid[0])
dp = [[0]*col for _ in range(row)]
# 首位置
dp[0][0] = 1 if obstacleGrid[0][0] != 1 else 0
if dp[0][0] == 0: return 0
# 第一行
for j in range(1, col):
if obstacleGrid[0][j] != 1:
dp[0][j] = dp[0][j-1]
# 第一列
for i in range(1, row):
if obstacleGrid[i][0] != 1:
dp[i][0] = dp[i-1][0]
for i in range(1, row):
for j in range(1, col):
if obstacleGrid[i][j] != 1:
dp[i][j] = dp[i-1][j] + dp[i][j-1]
return dp[-1][-1]
java
class Solution {
public int uniquePathsWithObstacles(int[][] obstacleGrid) {
if (obstacleGrid == null) return 0;
int[][] dp = new int[obstacleGrid.length][obstacleGrid[0].length];
// 第一个数
dp[0][0] = obstacleGrid[0][0] == 0 ? 1 : 0;
if (dp[0][0] == 0) return 0;
// 第一行
for (int j = 1; j < obstacleGrid[0].length; j++) {
if (obstacleGrid[0][j] != 1) {
dp[0][j] = dp[0][j - 1];
}
}
// 第一列
for (int i = 1; i < obstacleGrid.length; i++) {
if (obstacleGrid[i][0] != 1) {
dp[i][0] = dp[i - 1][0];
}
}
for (int i = 1; i < obstacleGrid.length; i++) {
for (int j = 1; j < obstacleGrid[0].length; j++) {
if (obstacleGrid[i][j] != 1) dp[i][j] = dp[i - 1][j] + dp[i][j - 1];
}
}
return dp[obstacleGrid.length - 1][obstacleGrid[0].length - 1];
}
}
python 自顶向下
class Solution:
def uniquePathsWithObstacles(self, obstacleGrid: List[List[int]]) -> int:
import functools
if not obstacleGrid or not obstacleGrid[0]: return 0
row = len(obstacleGrid)
col = len(obstacleGrid[0])
@functools.lru_cache(None)
def helper(i,j):
if i == row - 1 and j == col - 1 and obstacleGrid[i][j] != 1:
return 1
if i >= row or j >= col or obstacleGrid[i][j] == 1 :
return 0
tmp = 0
tmp += helper(i+1, j)
tmp += helper(i, j+1)
return tmp
return helper(0, 0)
以上是关于[LeetCode] 63. 不同路径 II的主要内容,如果未能解决你的问题,请参考以下文章